Project Chrono: chrono::vehicle::TranslationalDamperSuspension Class Reference

Public Member Functions | List of all members
chrono::vehicle::TranslationalDamperSuspension Class Reference
VEHICLE module » Tracked vehicles » Suspension subsystem

## Description

Torsion-bar suspension system using linear dampers constructed with data from file (JSON format).

`#include <TranslationalDamperSuspension.h>`

Inheritance diagram for chrono::vehicle::TranslationalDamperSuspension:
[legend]
Collaboration diagram for chrono::vehicle::TranslationalDamperSuspension:
[legend]

## Public Member Functions
| TranslationalDamperSuspension (const std::string &filename, bool has_shock, bool lock_arm)
| TranslationalDamperSuspension (const rapidjson::Document &d, bool has_shock, bool lock_arm)
virtual double | GetArmMass () const override
| Return the mass of the arm body.
virtual const ChVector3d & | GetArmInertia () const override
| Return the moments of inertia of the arm body.
virtual double | GetArmVisRadius () const override
| Return a visualization radius for the arm body.
virtual double | GetSpringRestAngle () const override
| Return the free (rest) angle of the spring element.
virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > | GetSpringTorqueFunctor () const override
| Return the functor object for the torsional spring torque.
virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > | GetDamperTorqueFunctor () const override
| Return the functor object for the (optional) linear rotational damper.
virtual std::shared_ptr< ChLinkTSDA::ForceFunctor > | GetShockForceFunctor () const override
| Return the functor object for the translational shock force.
Public Member Functions inherited from chrono::vehicle::ChTranslationalDamperSuspension
| ChTranslationalDamperSuspension (const std::string &name, bool has_shock=true, bool lock_arm=false)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual std::shared_ptr< ChBody > | GetCarrierBody () const override
| Get a handle to the carrier body.
virtual double | GetCarrierAngle () const override
| Return the current pitch angle of the carrier body.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, const ChVector3d &location, ChTrackAssembly *track) override
| Initialize this suspension subsystem.
virtual ForceTorque | ReportSuspensionForce () const override
| Return current suspension forces or torques, as appropriate (spring and shock).
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the suspension subsystem.
virtual void | RemoveVisualizationAssets () override final
| Remove visualization assets for the suspension subsystem.
void | LogConstraintViolations () override
| Log current constraint violations.
Public Member Functions inherited from chrono::vehicle::ChTrackSuspension
GuidePinType | GetType () const
| Return the type of track shoe consistent with this road wheel.
std::shared_ptr< ChTrackWheel > | GetRoadWheel () const
| Return a handle to the road wheel subsystem.
std::shared_ptr< ChBody > | GetWheelBody () const
| Return the body of the idler wheel.
std::shared_ptr< ChLinkLockRevolute > | GetWheelRevolute () const
| Get a handle to the revolute joint of the road-wheel.
double | GetWheelRadius () const
| Get the radius of the road wheel.
virtual void | SetOutput (bool state) override
| Enable/disable output for this subsystem.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Types inherited from chrono::vehicle::ChTranslationalDamperSuspension
enum | PointId { ARM , ARM_WHEEL , ARM_CHASSIS , SHOCK_A , SHOCK_C , NUM_POINTS }
| Identifiers for the various hardpoints. More...
Protected Member Functions inherited from chrono::vehicle::ChTranslationalDamperSuspension
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual std::shared_ptr< ChVehicleBushingData > | getArmBushingData () const
| Return stiffness and damping data for the arm bushing.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChTrackSuspension
| ChTrackSuspension (const std::string &name, bool has_shock, bool lock_arm)
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChTranslationalDamperSuspension
std::shared_ptr< ChBody > | m_arm
| trailing arm body
std::shared_ptr< ChVehicleJoint > | m_joint
| joint arm-chassis
std::shared_ptr< ChLinkRSDA > | m_spring
| rotational spring
std::shared_ptr< ChLinkRSDA > | m_damper
| optional rotational damper
std::shared_ptr< ChLinkTSDA > | m_shock
| translational shock element
Protected Attributes inherited from chrono::vehicle::ChTrackSuspension
GuidePinType | m_type
| type of the track shoe matching this road wheel
bool | m_has_shock
| specifies whether or not the suspension has a damper
bool | m_lock_arm
| specified whether the suspension arm is locked
ChVector3d | m_rel_loc
| suspension subsystem location relative to chassis
std::shared_ptr< ChTrackWheel > | m_road_wheel
| road-wheel subsystem
ChTrackAssembly * | m_track
| containing track assembly
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ GetArmInertia()

virtual const ChVector3d & chrono::vehicle::TranslationalDamperSuspension::GetArmInertia | ( |  | ) | const
| inlineoverridevirtual

Return the moments of inertia of the arm body.

Implements chrono::vehicle::ChTranslationalDamperSuspension.

## ◆ GetArmMass()

virtual double chrono::vehicle::TranslationalDamperSuspension::GetArmMass | ( |  | ) | const
| inlineoverridevirtual

Return the mass of the arm body.

Implements chrono::vehicle::ChTranslationalDamperSuspension.

## ◆ GetArmVisRadius()

virtual double chrono::vehicle::TranslationalDamperSuspension::GetArmVisRadius | ( |  | ) | const
| inlineoverridevirtual

Return a visualization radius for the arm body.

Implements chrono::vehicle::ChTranslationalDamperSuspension.

## ◆ GetDamperTorqueFunctor()

virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > chrono::vehicle::TranslationalDamperSuspension::GetDamperTorqueFunctor | ( |  | ) | const
| inlineoverridevirtual

Return the functor object for the (optional) linear rotational damper.

Reimplemented from chrono::vehicle::ChTranslationalDamperSuspension.

## ◆ GetShockForceFunctor()

virtual std::shared_ptr< ChLinkTSDA::ForceFunctor > chrono::vehicle::TranslationalDamperSuspension::GetShockForceFunctor | ( |  | ) | const
| inlineoverridevirtual

Return the functor object for the translational shock force.

Implements chrono::vehicle::ChTranslationalDamperSuspension.

## ◆ GetSpringRestAngle()

virtual double chrono::vehicle::TranslationalDamperSuspension::GetSpringRestAngle | ( |  | ) | const
| inlineoverridevirtual

Return the free (rest) angle of the spring element.

Implements chrono::vehicle::ChTranslationalDamperSuspension.

## ◆ GetSpringTorqueFunctor()

virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > chrono::vehicle::TranslationalDamperSuspension::GetSpringTorqueFunctor | ( |  | ) | const
| inlineoverridevirtual

Return the functor object for the torsional spring torque.

Implements chrono::vehicle::ChTranslationalDamperSuspension.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/suspension/TranslationalDamperSuspension.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/suspension/TranslationalDamperSuspension.cpp